diff -Naur WebKit-r41128/autotools/webkit.m4 WebKit-r41128-nx/autotools/webkit.m4
--- WebKit-r41128/autotools/webkit.m4	2009-02-15 03:48:56.000000000 -0500
+++ WebKit-r41128-nx/autotools/webkit.m4	2009-02-23 16:01:26.040005950 -0500
@@ -120,17 +120,17 @@
 dnl determine the Unicode backend
 AC_MSG_CHECKING([which Unicode backend to use])
 AC_ARG_WITH(unicode_backend,
-            AC_HELP_STRING([--with-unicode-backend=@<:@icu@:>@],
+            AC_HELP_STRING([--with-unicode-backend=@<:@icu/glib@:>@],
                            [Select Unicode backend [default=icu]]),
-            [],[unicode_backend="icu"])
+            [],[with_unicode_backend="icu"])
 
-case "$unicode_backend" in
-     icu) ;;
-     *) AC_MSG_ERROR([Invalid Unicode backend: must be icu.]) ;;
+case "$with_unicode_backend" in
+  icu|glib) ;;
+  *) AC_MSG_ERROR([Invalid Unicode backend: must be icu or glib.]) ;;
 esac
-AC_MSG_RESULT([$unicode_backend])
-
-if test "$unicode_backend" = "icu"; then
+AC_MSG_RESULT([$with_unicode_backend])
+  
+if test "$with_unicode_backend" = "icu"; then
 	if test "$os_darwin" = "yes"; then
 		UNICODE_CFLAGS="-I\$(srcdir)/JavaScriptCore/icu -I\$(srcdir)/WebCore/icu"
 		UNICODE_LIBS="-licucore"
@@ -150,6 +150,19 @@
 		UNICODE_LIBS=`$icu_config --ldflags`
 	fi
 fi
+
+if test "$with_unicode_backend" = "glib"; then
+	PKG_CHECK_MODULES([UNICODE], [glib-2.0 pango >= 1.16.0])
+	AC_MSG_CHECKING([for libidn])
+	AC_CHECK_HEADER(idna.h,
+		AC_CHECK_LIB(idn, stringprep_check_version,
+			[libidn=yes UNICODE_LIBS="${UNICODE_LIBS} -lidn"], libidn=no),
+		libidn=no)
+	if test "$libidn" = "no" ; then
+		AC_MSG_ERROR([Libidn not found, needed for GLib unicode backend.])
+	fi
+fi
+
 AC_SUBST([UNICODE_CFLAGS])
 AC_SUBST([UNICODE_LIBS])
 ])
diff -Naur WebKit-r41128/autotoolsconfig.h.in WebKit-r41128-nx/autotoolsconfig.h.in
--- WebKit-r41128/autotoolsconfig.h.in	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/autotoolsconfig.h.in	2009-02-23 16:05:13.444005790 -0500
@@ -0,0 +1,113 @@
+/* autotoolsconfig.h.in.  Generated from configure.ac by autoheader.  */
+
+/* Define to enable JIT */
+#undef ENABLE_JIT
+
+/* Define to enable optimized arithmetic */
+#undef ENABLE_JIT_OPTIMIZE_ARITHMETIC
+
+/* Define to enable optimizing calls */
+#undef ENABLE_JIT_OPTIMIZE_CALL
+
+/* Define to enable optimized property access */
+#undef ENABLE_JIT_OPTIMIZE_PROPERTY_ACCESS
+
+/* Define to enable WREC */
+#undef ENABLE_WREC
+
+/* Define to 1 if you have the <dlfcn.h> header file. */
+#undef HAVE_DLFCN_H
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+#undef HAVE_INTTYPES_H
+
+/* Define to 1 if you have the <memory.h> header file. */
+#undef HAVE_MEMORY_H
+
+/* Define to 1 if you have the <pthread.h> header file. */
+#undef HAVE_PTHREAD_H
+
+/* Define to 1 if stdbool.h conforms to C99. */
+#undef HAVE_STDBOOL_H
+
+/* Define to 1 if you have the <stdint.h> header file. */
+#undef HAVE_STDINT_H
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#undef HAVE_STDLIB_H
+
+/* Define to 1 if you have the <strings.h> header file. */
+#undef HAVE_STRINGS_H
+
+/* Define to 1 if you have the <string.h> header file. */
+#undef HAVE_STRING_H
+
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#undef HAVE_SYS_STAT_H
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#undef HAVE_SYS_TYPES_H
+
+/* Define to 1 if you have the <unistd.h> header file. */
+#undef HAVE_UNISTD_H
+
+/* Define to 1 if the system has the type `_Bool'. */
+#undef HAVE__BOOL
+
+/* Define to disable debugging features */
+#undef NDEBUG
+
+/* Define to 1 if your C compiler doesn't accept -c and -o together. */
+#undef NO_MINUS_C_MINUS_O
+
+/* Name of package */
+#undef PACKAGE
+
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
+/* Define to 1 if you have the ANSI C header files. */
+#undef STDC_HEADERS
+
+/* Version number of package */
+#undef VERSION
+
+/* Define if target is DirectFB */
+#undef WTF_PLATFORM_DIRECTFB
+
+/* Define if target is X11 */
+#undef WTF_PLATFORM_X11
+
+/* Use stub va_list */
+#undef WTF_USE_JIT_STUB_ARGUMENT_VA_LIST
+
+/* Number of bits in a file offset, on hosts where this is settable. */
+#undef _FILE_OFFSET_BITS
+
+/* Define for large files, on AIX-style hosts. */
+#undef _LARGE_FILES
+
+/* Define to empty if `const' does not conform to ANSI C. */
+#undef const
+
+/* Define to `__inline__' or `__inline' if that's what the C compiler
+   calls it, or to nothing if 'inline' is not supported under any name.  */
+#ifndef __cplusplus
+#undef inline
+#endif
+
+/* Define to empty if the keyword `volatile' does not work. Warning: valid
+   code using `volatile' can become incorrect without. Disable with care. */
+#undef volatile
diff -Naur WebKit-r41128/configure.ac WebKit-r41128-nx/configure.ac
--- WebKit-r41128/configure.ac	2009-02-19 01:12:25.000000000 -0500
+++ WebKit-r41128-nx/configure.ac	2009-02-23 16:01:26.072006950 -0500
@@ -27,7 +27,7 @@
 LIBWEBKITGTK_VERSION=1:0:0
 AC_SUBST([LIBWEBKITGTK_VERSION])
 
-AM_INIT_AUTOMAKE([foreign subdir-objects tar-ustar])
+AM_INIT_AUTOMAKE([foreign subdir-objects])
 
 # host checking - inspired by the GTK+ configure.in
 # TODO: move these to webkit.m4?
@@ -607,6 +607,10 @@
 AM_CONDITIONAL([TARGET_QUARTZ], [test "$with_target" = "quartz"])
 AM_CONDITIONAL([TARGET_DIRECTFB], [test "$with_target" = "directfb"])
 
+# Unicode backend conditionals
+AM_CONDITIONAL([USE_ICU_UNICODE], [test "$with_unicode_backend" = "icu"])
+AM_CONDITIONAL([USE_GLIB_UNICODE], [test "$with_unicode_backend" = "glib"])
+
 # HTTP backend conditionals
 AM_CONDITIONAL([USE_CURL], [test "$with_http_backend" = "curl"])
 AM_CONDITIONAL([USE_SOUP], [test "$with_http_backend" = "soup"])
@@ -656,7 +660,7 @@
  Enable debugging (slow)                                  : $enable_debug
  Enable GCC build optimization                            : $enable_optimizations
  Code coverage support                                    : $enable_coverage
- Unicode backend                                          : $unicode_backend
+ Unicode backend                                          : $with_unicode_backend
  HTTP backend                                             : $with_http_backend
  Font backend                                             : $with_font_backend
  Optimized memory allocator                               : $enable_fast_malloc
diff -Naur WebKit-r41128/debian/changelog WebKit-r41128-nx/debian/changelog
--- WebKit-r41128/debian/changelog	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/changelog	2009-02-23 16:03:25.776005910 -0500
@@ -0,0 +1,71 @@
+webkit (1.0-svn41128-1) unstable; urgency=high
+
+    * Update from upstream.
+    * Some tests.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 23 Jan 2009 02:00:00 +0200
+ 
+webkit (1.0-svn41071-1) unstable; urgency=high
+
+    * Update from upstream.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 20 Jan 2009 02:00:00 +0200
+ 
+webkit (1.0-svn40663-1) unstable; urgency=high
+
+    * Update from upstream.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 06 Jan 2009 02:00:00 +0200
+ 
+webkit (1.0-svn40419-1) unstable; urgency=high
+
+    * Handling text/plain MIME types as downloads - like Mozilla does.
+    * Different way to get the Content-Length - CURL doesn't seem to do it.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 31 Jan 2009 22:00:00 +0200
+
+webkit (1.0-svn40239-3) unstable; urgency=high
+
+    * Changed some dependencies to allow installation on Chinook.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 28 Jan 2009 23:30:00 +0200
+
+webkit (1.0-svn40239-2) unstable; urgency=high
+
+    * Switched on some optimizations.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 27 Jan 2009 03:00:00 +0200
+
+webkit (1.0-svn40239-1) unstable; urgency=high
+
+    * Updated to 40239.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 27 Jan 2009 01:00:00 +0200
+
+webkit (1.0-svn40080-1) unstable; urgency=high
+
+    * Updated to 40080.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 22 Jan 2009 01:00:00 +0200
+ 
+webkit (1.0-svn39682-1) unstable; urgency=high
+
+    * Updated to 39682.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 09 Jan 2009 23:00:00 +0200
+ 
+webkit (1.0-svn39572-1) unstable; urgency=high
+
+    * Patch for unicode handling with GLib.
+    * Patch for download support.
+    * Patch for inspect support.
+    * Maemo PASSWORD input field support with INVISIBLE input mode.
+    * Web inspector files included in package.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 04 Jan 2009 20:00:00 +0200
+
+webkit (1.0-svn39572) unstable; urgency=high
+
+    * Packaged for Maemo. No changes from SVN 39572.
+
+ -- Bundyo <bundyo@gmail.com>  Tue, 03 Jan 2009 20:57:48 +0200
\ No newline at end of file
diff -Naur WebKit-r41128/debian/compat WebKit-r41128-nx/debian/compat
--- WebKit-r41128/debian/compat	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/compat	2009-02-23 16:01:26.129006270 -0500
@@ -0,0 +1 @@
+4
diff -Naur WebKit-r41128/debian/control WebKit-r41128-nx/debian/control
--- WebKit-r41128/debian/control	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/control	2009-02-23 16:01:26.156732550 -0500
@@ -0,0 +1,53 @@
+Source: webkit
+Priority: optional
+Section: user/other
+Uploaders: Bundyo <bundyo@gmail.com>
+Build-Depends: debhelper (>= 5.0), libgtk2.0-dev (>= 2.10), libpango1.0-dev (>= 1.16), libxslt-dev, libcurl3-dev, libsqlite3-dev, bison, flex, libjpeg62-dev, libpng12-dev, autoconf, automake, libtool, libxt-dev
+Standards-Version: 3.8.0.1
+Homepage: http://webkit.org/
+
+Package: libwebkit-1.0-1
+Section: user/other
+Architecture: any
+Depends: ${shlibs:Depends}
+Description: Web content engine library for Gtk+
+ WebKit is a web content engine, derived from KHTML and KJS from KDE, and
+ used primarily in Apple's Safari browser.  It is made to be embedded in
+ other applications, such as mail readers, or web browsers.
+ .
+ It is able to display content such as HTML, SVG, XML, and others. It also
+ supports DOM, XMLHttpRequest, XSLT, CSS, Javascript/ECMAscript and more.
+ .
+ This is the library for embedding in Gtk+ applications.
+
+Package: libwebkit-dev
+Section: libdevel
+Priority: extra
+Architecture: all
+Depends: libwebkit-1.0-1 (>= ${source:Upstream-Version}), libgtk2.0-dev
+Conflicts: libwebkitgdk-dev
+Description: Web content engine library for Gtk+ - Development files
+ WebKit is a web content engine, derived from KHTML and KJS from KDE, and
+ used primarily in Apple's Safari browser.  It is made to be embedded in
+ other applications, such as mail readers, or web browsers.
+ .
+ It is able to display content such as HTML, SVG, XML, and others. It also
+ supports DOM, XMLHttpRequest, XSLT, CSS, Javascript/ECMAscript and more.
+ .
+ This package provides development files required to create Gtk+ applications
+ embedding WebKit.
+
+Package: libwebkit-1.0-1-dbg
+Section: libdevel
+Priority: extra
+Architecture: any
+Depends: libwebkit-1.0-1 (= ${binary:Version})
+Description: Web content engine library for Gtk+ - Debugging symbols
+ WebKit is a web content engine, derived from KHTML and KJS from KDE, and
+ used primarily in Apple's Safari browser.  It is made to be embedded in
+ other applications, such as mail readers, or web browsers.
+ .
+ It is able to display content such as HTML, SVG, XML, and others. It also
+ supports DOM, XMLHttpRequest, XSLT, CSS, Javascript/ECMAscript and more.
+ .
+ This package provides the debugging symbols for the Webkit library for Gtk+.
